#!/bin/python3
#%%
import os, sys
import numpy as np
import pandas as pd
from tools.mdl_kit_v6 import t_print, auto_params_v2, clf_stat, count_down, json_load
from tools.y_funcs import get_split_xy
from p9_funcs import get_src_features, get_y_p9
# from tools.var import params_dict

# count_down(np.random.random()*512)

#%%
print('\n'*2)

#%%
if len(sys.argv) == 3:
    batch = sys.argv[1]
    source = sys.argv[2]

prefix = f'{batch}-{source}-LGBM'
results_path = './results_240416/'
clfs_path = os.path.join(results_path, prefix)

#%%
print('\nprefix =', prefix, '\n')
count_down(8)

#%%
if os.path.exists(clfs_path) and False :
    col_params = params_dict[prefix]
    cs = clf_stat(path = clfs_path)
    valid_cols = cs.manual_select(**col_params, ret = 'keys')
else:
    valid_cols = None


#%%
data_df = get_src_features(batch=batch, src=source)
y_df = get_y_p9(batch, mode = 2)

#%%
XY3 = get_split_xy(batch=y_df, x_df=data_df)
X3 = XY3[:3]
Y3 = XY3[3:]

settings_dict = {
    'results_path': results_path,
    'prefix': prefix,
    'DS.random_state': 0,

   'clf_tag': 'LGBM',
   
   'LGBM.num_leaves': [20],
   'LGBM.max_depth': [1, 2, 3],
   'LGBM.learning_rate': [.01, .1],
   'LGBM.n_estimators': [50, 100],
   'LGBM.min_child_samples': [20, 100]
}

# auto_params_v2(X3, Y3, settings_dict)

t_print(f'end of {prefix}')
