#!/bin/python3
#%%
import pandas as pd
from tools.mdl_kit_v6 import t_print

#%%
def get_src_features(batch: str, src: str):
    if src in [2,3,4,5,7]:
        origin_src = src
        src = f'S0{src}'
    src_dict = {
        # 'S01': '',
        'S02': 'YS',
        'S03': 'JD',
        'S04': 'YK',
        'S05': 'TD',
        # 'S06': '',
        'S07': 'S07',
    }
    if src in src_dict:
        print(f'source: {src} -> {src_dict[src]}')
        src = src_dict[src]
    if src == 'YS':
        path = f'./data/s237_data/{batch}-S02-t8-step2-pickle'
    elif src == 'JD':
        path = f'./data/s237_data/{batch}-S03-a-step2-pickle'
    elif src == 'YK':
        path = f'./data/S04/{batch}-S04-origin-pickle'
    elif src == 'TD':
        path = f'./data/S05/{batch}-S05-fs_and_tn-pickle'
    elif src == 'S07':
        path = f'./data/s237_data/{batch}-S07-origin-pickle'
    t_print('read', path)
    df = pd.read_pickle(path)
    idx = ~df.isna().all(axis = 1)
    n1 = len(df)
    df = df.loc[idx, :]
    n2 = len(df)
    print('nrow:', n1, '->', n2)

    path = f'./stat/cnt/{batch}-S0{origin_src}-cnt.csv'
    cnt_df = pd.read_csv(path)
    cnt_cols = cnt_df['col_name'][cnt_df['to_mdl']].to_list()
    print('cnt:', len(cnt_df), '->', len(cnt_cols))
    path = f'./stat/psi/{batch}-S0{origin_src}-psi.csv'
    psi_df = pd.read_csv(path, index_col=0)
    psi_cols = psi_df.loc[psi_df['max_psi'] < .05, :].index.to_list()
    print('psi:', len(psi_df), '->', len(psi_cols))
    usecols = sorted(set(cnt_cols) & set(psi_cols))
    print('intersec:', df.shape[1], '->', len(usecols))

    df = df[usecols]
    t_print(df)
    print('\n\n')

    return df

batch = 'p9_a'
for src in [2, 3, 4, 5, 7]:
    get_src_features(batch=batch, src=src)
